// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from nao_command_msgs:msg/JointIndexes.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "nao_command_msgs/msg/joint_indexes.h"


#ifndef NAO_COMMAND_MSGS__MSG__DETAIL__JOINT_INDEXES__FUNCTIONS_H_
#define NAO_COMMAND_MSGS__MSG__DETAIL__JOINT_INDEXES__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/action_type_support_struct.h"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_runtime_c/service_type_support_struct.h"
#include "rosidl_runtime_c/type_description/type_description__struct.h"
#include "rosidl_runtime_c/type_description/type_source__struct.h"
#include "rosidl_runtime_c/type_hash.h"
#include "rosidl_runtime_c/visibility_control.h"
#include "nao_command_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "nao_command_msgs/msg/detail/joint_indexes__struct.h"

/// Initialize msg/JointIndexes message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * nao_command_msgs__msg__JointIndexes
 * )) before or use
 * nao_command_msgs__msg__JointIndexes__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
bool
nao_command_msgs__msg__JointIndexes__init(nao_command_msgs__msg__JointIndexes * msg);

/// Finalize msg/JointIndexes message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
void
nao_command_msgs__msg__JointIndexes__fini(nao_command_msgs__msg__JointIndexes * msg);

/// Create msg/JointIndexes message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * nao_command_msgs__msg__JointIndexes__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
nao_command_msgs__msg__JointIndexes *
nao_command_msgs__msg__JointIndexes__create();

/// Destroy msg/JointIndexes message.
/**
 * It calls
 * nao_command_msgs__msg__JointIndexes__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
void
nao_command_msgs__msg__JointIndexes__destroy(nao_command_msgs__msg__JointIndexes * msg);

/// Check for msg/JointIndexes message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
bool
nao_command_msgs__msg__JointIndexes__are_equal(const nao_command_msgs__msg__JointIndexes * lhs, const nao_command_msgs__msg__JointIndexes * rhs);

/// Copy a msg/JointIndexes message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
bool
nao_command_msgs__msg__JointIndexes__copy(
  const nao_command_msgs__msg__JointIndexes * input,
  nao_command_msgs__msg__JointIndexes * output);

/// Retrieve pointer to the hash of the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
const rosidl_type_hash_t *
nao_command_msgs__msg__JointIndexes__get_type_hash(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
const rosidl_runtime_c__type_description__TypeDescription *
nao_command_msgs__msg__JointIndexes__get_type_description(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the single raw source text that defined this type.
ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
const rosidl_runtime_c__type_description__TypeSource *
nao_command_msgs__msg__JointIndexes__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the recursive raw sources that defined the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
const rosidl_runtime_c__type_description__TypeSource__Sequence *
nao_command_msgs__msg__JointIndexes__get_type_description_sources(
  const rosidl_message_type_support_t * type_support);

/// Initialize array of msg/JointIndexes messages.
/**
 * It allocates the memory for the number of elements and calls
 * nao_command_msgs__msg__JointIndexes__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
bool
nao_command_msgs__msg__JointIndexes__Sequence__init(nao_command_msgs__msg__JointIndexes__Sequence * array, size_t size);

/// Finalize array of msg/JointIndexes messages.
/**
 * It calls
 * nao_command_msgs__msg__JointIndexes__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
void
nao_command_msgs__msg__JointIndexes__Sequence__fini(nao_command_msgs__msg__JointIndexes__Sequence * array);

/// Create array of msg/JointIndexes messages.
/**
 * It allocates the memory for the array and calls
 * nao_command_msgs__msg__JointIndexes__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
nao_command_msgs__msg__JointIndexes__Sequence *
nao_command_msgs__msg__JointIndexes__Sequence__create(size_t size);

/// Destroy array of msg/JointIndexes messages.
/**
 * It calls
 * nao_command_msgs__msg__JointIndexes__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
void
nao_command_msgs__msg__JointIndexes__Sequence__destroy(nao_command_msgs__msg__JointIndexes__Sequence * array);

/// Check for msg/JointIndexes message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
bool
nao_command_msgs__msg__JointIndexes__Sequence__are_equal(const nao_command_msgs__msg__JointIndexes__Sequence * lhs, const nao_command_msgs__msg__JointIndexes__Sequence * rhs);

/// Copy an array of msg/JointIndexes messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
bool
nao_command_msgs__msg__JointIndexes__Sequence__copy(
  const nao_command_msgs__msg__JointIndexes__Sequence * input,
  nao_command_msgs__msg__JointIndexes__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // NAO_COMMAND_MSGS__MSG__DETAIL__JOINT_INDEXES__FUNCTIONS_H_
