// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from nao_command_msgs:msg/LeftEarLeds.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "nao_command_msgs/msg/left_ear_leds.h"


#ifndef NAO_COMMAND_MSGS__MSG__DETAIL__LEFT_EAR_LEDS__FUNCTIONS_H_
#define NAO_COMMAND_MSGS__MSG__DETAIL__LEFT_EAR_LEDS__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/action_type_support_struct.h"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_runtime_c/service_type_support_struct.h"
#include "rosidl_runtime_c/type_description/type_description__struct.h"
#include "rosidl_runtime_c/type_description/type_source__struct.h"
#include "rosidl_runtime_c/type_hash.h"
#include "rosidl_runtime_c/visibility_control.h"
#include "nao_command_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "nao_command_msgs/msg/detail/left_ear_leds__struct.h"

/// Initialize msg/LeftEarLeds message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * nao_command_msgs__msg__LeftEarLeds
 * )) before or use
 * nao_command_msgs__msg__LeftEarLeds__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
bool
nao_command_msgs__msg__LeftEarLeds__init(nao_command_msgs__msg__LeftEarLeds * msg);

/// Finalize msg/LeftEarLeds message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
void
nao_command_msgs__msg__LeftEarLeds__fini(nao_command_msgs__msg__LeftEarLeds * msg);

/// Create msg/LeftEarLeds message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * nao_command_msgs__msg__LeftEarLeds__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
nao_command_msgs__msg__LeftEarLeds *
nao_command_msgs__msg__LeftEarLeds__create();

/// Destroy msg/LeftEarLeds message.
/**
 * It calls
 * nao_command_msgs__msg__LeftEarLeds__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
void
nao_command_msgs__msg__LeftEarLeds__destroy(nao_command_msgs__msg__LeftEarLeds * msg);

/// Check for msg/LeftEarLeds message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
bool
nao_command_msgs__msg__LeftEarLeds__are_equal(const nao_command_msgs__msg__LeftEarLeds * lhs, const nao_command_msgs__msg__LeftEarLeds * rhs);

/// Copy a msg/LeftEarLeds message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
bool
nao_command_msgs__msg__LeftEarLeds__copy(
  const nao_command_msgs__msg__LeftEarLeds * input,
  nao_command_msgs__msg__LeftEarLeds * output);

/// Retrieve pointer to the hash of the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
const rosidl_type_hash_t *
nao_command_msgs__msg__LeftEarLeds__get_type_hash(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
const rosidl_runtime_c__type_description__TypeDescription *
nao_command_msgs__msg__LeftEarLeds__get_type_description(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the single raw source text that defined this type.
ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
const rosidl_runtime_c__type_description__TypeSource *
nao_command_msgs__msg__LeftEarLeds__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the recursive raw sources that defined the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
const rosidl_runtime_c__type_description__TypeSource__Sequence *
nao_command_msgs__msg__LeftEarLeds__get_type_description_sources(
  const rosidl_message_type_support_t * type_support);

/// Initialize array of msg/LeftEarLeds messages.
/**
 * It allocates the memory for the number of elements and calls
 * nao_command_msgs__msg__LeftEarLeds__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
bool
nao_command_msgs__msg__LeftEarLeds__Sequence__init(nao_command_msgs__msg__LeftEarLeds__Sequence * array, size_t size);

/// Finalize array of msg/LeftEarLeds messages.
/**
 * It calls
 * nao_command_msgs__msg__LeftEarLeds__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
void
nao_command_msgs__msg__LeftEarLeds__Sequence__fini(nao_command_msgs__msg__LeftEarLeds__Sequence * array);

/// Create array of msg/LeftEarLeds messages.
/**
 * It allocates the memory for the array and calls
 * nao_command_msgs__msg__LeftEarLeds__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
nao_command_msgs__msg__LeftEarLeds__Sequence *
nao_command_msgs__msg__LeftEarLeds__Sequence__create(size_t size);

/// Destroy array of msg/LeftEarLeds messages.
/**
 * It calls
 * nao_command_msgs__msg__LeftEarLeds__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
void
nao_command_msgs__msg__LeftEarLeds__Sequence__destroy(nao_command_msgs__msg__LeftEarLeds__Sequence * array);

/// Check for msg/LeftEarLeds message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
bool
nao_command_msgs__msg__LeftEarLeds__Sequence__are_equal(const nao_command_msgs__msg__LeftEarLeds__Sequence * lhs, const nao_command_msgs__msg__LeftEarLeds__Sequence * rhs);

/// Copy an array of msg/LeftEarLeds messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
bool
nao_command_msgs__msg__LeftEarLeds__Sequence__copy(
  const nao_command_msgs__msg__LeftEarLeds__Sequence * input,
  nao_command_msgs__msg__LeftEarLeds__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // NAO_COMMAND_MSGS__MSG__DETAIL__LEFT_EAR_LEDS__FUNCTIONS_H_
